/*	$Id: GenMETHOD.c,v 1.1 91/02/25 16:15:52 jdf Exp $
 *	$CurLog$	(Log at end)
 */
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

static	int	in_ifdef_cplus;
static	int	in_cplus_proto;
static	char	widget_name[100];

static void
find_widget_name (char* line)
{
	char* class;
	int len;

	if (strncmp (line, "typedef struct", 14) != 0)
		return;
	if (! (class = strstr(line, "WidgetClass")))
		return;
	for (class--, len = 0;
	     class != line && *class != '*' && ! isspace (*class);
	     class--, len++) ;
	if (! len)
		return;

	strncpy (widget_name, class+1, len);
	widget_name[len] = 0;
	printf("// widget name = %s\n", widget_name);
}

static void
parse_line (char* line)
{
	char*	pline;
	char*	type;
	int	type_len;
	char*	fn_name;
	int	fn_name_len;
	int	i;
	char*	args;
	char*	arg;

	if (in_ifdef_cplus) {
		if (! strncmp (line, "extern \"C\" {\n", 13)) {
			in_cplus_proto++;
			return;
		} else if (! strncmp (line, "}\n", 2)) {
			in_cplus_proto--;
			return;
		} else
			in_ifdef_cplus = 0;
	}
	if (line[0] == '#') {
		if (! strncmp (line+1,
			       "if defined(__cplusplus) || defined(c_plusplus)\n",
			       47))
			in_ifdef_cplus = 1;
		return;
	}
	if (! in_cplus_proto)
		return;

	if (strncmp (line, "extern", 5))
		return;

	pline = line + 6;
	if (! isspace (*pline))
		return;
	while (isspace (*pline))
		pline++;
	
	type = pline;

	for (type_len = 0; ! isspace (*pline) && *pline; pline++, type_len++) ;
	if (*pline == 0)
		return;
	while (isspace (*pline) && *pline) {
		type_len ++;
		pline++;
	}
	if (*pline == 0)
		return;
	else if (*pline == '*') {
		pline++;
		type_len++;
		while (isspace (*pline))
		       pline++;
	}
	fn_name = widget_name;
	while (*fn_name == *pline) {
		fn_name++;
		pline++;
	}
	/* does not match widget name */
	if (*fn_name != 0)
		return;
	fn_name = pline;
	fn_name_len = 0;
	while (*pline && ! isspace (*pline) && *pline != '(') {
		pline++;
		fn_name_len++;
	}
	if (*pline == 0)
		return;
	while (*pline != '(' && *pline)
		pline++;
	if (*pline == 0)
		return;
	pline++;
	while (isspace (*pline))
		pline++;
	if (strncmp (pline, "Widget ", 7) != 0)
		return;
	/* skip widget are name */
	while (*pline != ',' && *pline != ')')
		pline++;
	args = pline;

	fputs ("inline ", stdout);

	for (i = 0; i < type_len; i++)
		putchar (type [i]);
	putchar ('\t');
	for (i = 0; i < fn_name_len; i++)
		putchar(fn_name[i]);
	putchar (' ');
	putchar ('(');
	if (*pline == ')')
		putchar (')');
	else
		while (*pline != ')' && *pline) {
			pline++; /* skip the ',' */
			putchar (*pline);
		}
	fputs (" const { ", stdout);
	if (strncmp (type, "void", 4) != 0 ||
	    type[type_len-1] == '*')
		fputs (" return ", stdout);
	fputs (widget_name, stdout);
	for (i = 0; i < fn_name_len; i++)
		putchar (fn_name[i]);
	fputs (" (widget", stdout);
	while (*args != ')') {
		/* we are on a ',' */
		args++;
		putchar (',');
		putchar (' ');
		arg = args;
		while (*args != ',' && *args != ')') {
			if (isspace (*args) || *args == '*')
				arg = args + 1;
			args++;
		}
		while (arg != args) {
			putchar (*arg);
			arg++;
		}
	}
	fputs ("); }\n", stdout);
}

int
main (int argc, char* argv[])
{
	char buffer[1024];

	while (fgets (buffer, 1024, stdin) != NULL && widget_name[0] == 0)
		find_widget_name (buffer);
	while (fgets (buffer, 1024, stdin) != NULL)
		parse_line (buffer);
}
