// This may look like C code, but it is really -*- C++ -*-

#ifndef _trywin_h
#define _trywin_h

#include "WWL/Shell.h"
#include "WWL/ApplicationShell.h"
#include "WWL/XmDialogShell.h"
#include "WWL/XmForm.h"
#include "WWL/menu.h"
#include "WWL/radiobox.h"
#include "WWL/XmList.h"
#include "WWL/XmFrame.h"
#include "WWL/XmScale.h"
#include "WWL/XmScrollBar.h"
#include "WWL/XmScrolledWindow.h"
#include "WWL/XmSelectionBox.h"
#include "WWL/XmFileSelectionBox.h"
#include "WWL/XmMessageBox.h"
#include "WWL/XmDrawingArea.h"

class TryWindow : public WWL {
protected :
	WApplicationShell	toplevel;
	WXmForm			main_window;
	WXmMenuBar			menu_bar;
	WXmPulldownMenu 			file_menu;
	WXmFileSelectionBox				save_files;
	WXmFileSelectionBox				load_files;
	WXmMessageBox					message;
	WXmPulldownMenu				edit_menu;
	WXmPulldownMenu				view_menu;
	WXmSelectionBox 				systems;
	WXmPulldownMenu				tools_menu;
#define DEFINE_TOOL(n,a) \
	WXmToggleButtonGadget				_concat(n,_toggle);
#include "tools.def"
	WXmRadioBox			tools;
	WXmFrame			frame;
	WXmScrolledWindow			scrolled;
	WXmDrawingArea				view;

protected :
  	void		HandleQuit(WCallback*);
	void		ReallyQuit(WCallback*);
  	void		HandleHelp (WCallback*);
	void		HandleNew (WCallback*);
	void		HandleLoad (WCallback*);
	void		HandleSave (WCallback*);
	void		HandleSaveAs (WCallback*);
	void		HandleNewView (WCallback*);
	void		HandleNewWindow (WCallback*);
	void		HandleDeleteView (WCallback*);
	void		HandleSelectAll (WCallback*);
	void		HandleCut (WCallback*);
	void		HandlePaste (WCallback*);
	void		HandleCopy (WCallback*);
	void		HandleDelete (WCallback*);
#define DEFINE_TOOL(n,a) \
	void		_concat(HandleTool,n) (WCallback*);
#include "tools.def"

public :
			TryWindow (Display*);
			~TryWindow ();

  	void		Destroy ();
	void		Error (char*);
	void		Message (char*);
	void		Confirm (char*, WWL_FUN);
};

#endif

