#ifndef _CC_XmString_h
#define _CC_XmString_h

class WXmString {
protected :
  XmString	string;

public :
inline			WXmString (char* t, XmStringCharSet charset = XmSTRING_DEFAULT_CHARSET)
  			{ string = XmStringCreateLtoR (t, charset); }
inline			WXmString (XmStringDirection d)	{ string = XmStringDirectionCreate (d); }
inline			WXmString (XmString s = 0)	{ string = s; }
inline			WXmString (const WXmString& w)	{ string = w.string; }
inline		operator XmString () const	{ return string; }
inline		operator char*	() const	{ char* ret; XmStringGetLtoR (string, XmSTRING_DEFAULT_CHARSET, &ret); return ret; }
inline		operator XtArgVal () const	{ return (XtArgVal) string; }
//inline			~WXmString ()	{ if (string) XmStringFree (string); }
inline	void		Free ()		{ if (string) XmStringFree (string); string = 0; }
inline	void		Zero ()		{ string = 0; }
inline	Dimension	Baseline (XmFontList fl) const	{ return XmStringBaseline (fl, string); }
inline	Boolean		ByteCompare (XmString s) const	{ return XmStringByteCompare (string, s); }
inline	Boolean		Compare (XmString s) const { return XmStringCompare (string, s); }
inline	Boolean		operator == (XmString s) const { return ByteCompare (s); }
inline	XmString	Concat (XmString s) const { return XmStringConcat (string, s); }
inline	WXmString&	operator << (const WXmString& s)	{ XmString n = Concat (s.string); XmStringFree(string); string = n; return *this; }
inline	XmString	Copy () const			{ return XmStringCopy (string); }
inline	Boolean		Empty () const			{ return XmStringEmpty (string); }
inline	void		Extent (XmFontList fl, Dimension* w, Dimension* h) const { XmStringExtent (fl, string, w, h); }
inline	Boolean		GetLtoR (char** text, XmStringCharSet cs) const { return XmStringGetLtoR (string, cs, text); }
inline	Dimension	Height (XmFontList fl) const	{ return XmStringHeight (fl, string); }
inline	int		LineCount () const		{ return XmStringLineCount (string); }
inline	void		NConcat (XmString s, int n)	{ XmStringNConcat (string, s, n); }
inline	Dimension	Width (XmFontList fl) const	{ return XmStringWidth (fl, string); }
};

#endif
